#include <iostream>
using namespace std;
bool isMagicSquare(int** square, int n) {
    int sum = 0;

    for (int j = 0; j < n; ++j) {
        sum += square[0][j];
    }

    for (int i = 0; i < n; ++i) {
        int rowSum = 0;
        int colSum = 0;

        for (int j = 0; j < n; ++j) {
            rowSum += square[i][j];
            colSum += square[j][i];
        }

        if (rowSum != sum || colSum != sum) {
            return false;
        }
    }

    int diagSum = 0;
    for (int i = 0; i < n; ++i) {
        diagSum += square[i][i];
    }
    if (diagSum != sum) {
        return false;
    }

    diagSum = 0;
    for (int i = 0; i < n; ++i) {
        diagSum += square[i][n - i - 1];
    }
    if (diagSum != sum) {
        return false;
    }

    return true;
}

int main() {
    int n;
    cin >> n;

    int** square = new int*[n];
    for (int i = 0; i < n; ++i) {
        square[i] = new int[n];
        for (int j = 0; j < n; ++j) {
            cin >> square[i][j];
        }
    }

    if (isMagicSquare(square, n)) {
        cout << "MAGIC SQUARE" << endl;
    } else {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                int original = square[i][j];
                for (int num = 1; num <= 100; ++num) {
                    square[i][j] = num;
                    if (isMagicSquare(square, n)) {
                        cout << i + 1 << " " << j + 1 << " " << num << endl;
                        return 0;
                    }
                }
                square[i][j]=original;
            }
        }
        cout<<"IMPOSSIBLE"<<endl;
    }


    return 0;
}
