#include <iostream>
using namespace std;
bool isMagicSquare(long long** square, long long n) {
    long long sum = 0;

    for (long long j = 0; j < n; ++j) {
        sum += square[0][j];
    }

    for (long long i = 0; i < n; ++i) {
        long long rowSum = 0;
        long long colSum = 0;

        for (long long j = 0; j < n; ++j) {
            rowSum += square[i][j];
            colSum += square[j][i];
        }

        if (rowSum != sum || colSum != sum) {
            return false;
        }
    }

    long long diagSum = 0;
    for (long long i = 0; i < n; ++i) {
        diagSum += square[i][i];
    }
    if (diagSum != sum) {
        return false;
    }

    diagSum = 0;
    for (long long i = 0; i < n; ++i) {
        diagSum += square[i][n - i - 1];
    }
    if (diagSum != sum) {
        return false;
    }

    return true;
}

int main() {
    long long n;
    cin >> n;

    long long** square = new long long*[n];
    for (long long i = 0; i < n; ++i) {
        square[i] = new long long[n];
        for (long long j = 0; j < n; ++j) {
            cin >> square[i][j];
        }
    }

    if (isMagicSquare(square, n)) {
        cout << "MAGIC SQUARE" << endl;
    } else {
        for (long long i = 0; i < n; ++i) {
            for (long long j = 0; j < n; ++j) {
                long long original = square[i][j];
                for (long long num = 1; num <= 100; ++num) {
                    square[i][j] = num;
                    if (isMagicSquare(square, n)) {
                        cout << i + 1 << " " << j + 1 << " " << num << endl;
                        return 0;
                    }
                }
                square[i][j]=original;
            }
        }
        cout<<"IMPOSSIBLE"<<endl;
    }


    return 0;
}
